#include <FastLED.h>
#define LED_PIN     5
#define NUM_LEDS    144
CRGB leds[NUM_LEDS];

void setup() {
  FastLED.addLeds<WS2812, LED_PIN, GRB>(leds, NUM_LEDS);
  fill_solid(leds, NUM_LEDS, CRGB(0,0,0));         // fill all black
  FastLED.show();
}
void loop() {  
  onesnake(10000);
  fill_solid(leds, NUM_LEDS, CRGB(0,0,0));
  fadeFromCenter(10000);
  fill_solid(leds, NUM_LEDS, CRGB(0,0,0));
  //rainbow(10000);
  fill_solid(leds, NUM_LEDS, CRGB(0,0,0));
  sparkles(10000);
  fill_solid(leds, NUM_LEDS, CRGB(0,0,0));
  //loopThroughColors(10000);
  fill_solid(leds, NUM_LEDS, CRGB(0,0,0));
}
void onesnake( int duration){
  unsigned long startTime;
  startTime=millis();
  int location=1;
  int nextpath =1;
  int corners[8][3] = {{-7,8,1},{-1,2,3},{-3,4,5},{-5,6,7},{-8,-12,9},{-2,-9,10},{-4,-10,11},{-6,-11,12}};
  int ledsInSnake[48];
  int color=0;
  for (int i=0;i<48;i++){
    ledsInSnake[i]=0;
  }
  while(startTime+duration>millis()){
    if (location>0){
      for(int i=0;i<12;i++){
        color=(color+5)%2550;
        leds[ledsInSnake[0]]=CHSV(255, 255, 0);
        for(int j = 0; j < 48; j++){
          if (j!=0){
            leds[ledsInSnake[j]]=CHSV(color/10,255, (j*255)/48);
            ledsInSnake[j-1]=ledsInSnake[j];
          }
        }
        ledsInSnake[47]=(location-1)*12+i;
        leds[ledsInSnake[47]]=CHSV(color/10,255, 255);
        FastLED.show();
        delay(20); 
      }
    }
    if (location<0){
      for(int i=0;i<12;i++){
        color=(color+5)%2550;
        leds[ledsInSnake[0]]=CHSV(255, 255, 0);
        for(int j = 0; j < 48; j++){
          if (j!=0){
            leds[ledsInSnake[j]]=CHSV(color/10,255, (j*255)/48);
            ledsInSnake[j-1]=ledsInSnake[j];
          }
        }
        ledsInSnake[47]=(location+1)*-12+11-i;
        leds[ledsInSnake[47]]=CHSV(color/10,255, 255);
        FastLED.show();
        delay(20); 
      }      
    }
    nextpath=random(0,2);
    for (int i=0; i<8;i++){//differen 8
      if (corners[i][0]==-location || corners[i][1]==-location || corners[i][2]==-location){
        if (corners[i][nextpath]!=-location){
          location=corners[i][nextpath];
        }else{
          location=corners[i][nextpath+1];
        }
        break;
      }
    }



    FastLED.show();
    delay(20); 
  }
}
void fadeFromCenter( int duration){
  unsigned long startTime;
  startTime=millis();
  int counter = 0;
  while(startTime+duration>millis()){
    counter=(counter+1)%255;
    for (int i=0;i<12;i++){
      for (int j=0;j<6;j++){
        leds[i*12+j]=CHSV((counter+j*15)%255,255,255);
        leds[i*12+11-j]=CHSV((counter+j*15)%255,255,255);
      }
    }
    FastLED.show();
    delay(20); 
  }
}
 void loopThroughColors(int duration){
  unsigned long startTime;
  startTime=millis();
  int counter = 0;
  while(startTime+duration>millis()){
    counter=(counter+1)%255;
    for ( int i=0;i<NUM_LEDS;i++){
      leds[i]=CHSV(counter,255,255);    
    }
    FastLED.show();
    delay(20);  
  }
 }

void rainbow(int duration){
  unsigned long startTime;
  startTime=millis();
  int counter = 0;
  while(startTime+duration>millis()){
    counter=(counter+1)%255;
    for(int i = 0; i < NUM_LEDS; i++){
      leds[i]=CHSV((i*5+counter)%255, 255, 255);
    }
    FastLED.show();
    delay(20);  
  }
}
void sparkles(int duration){
  unsigned long startTime;
  startTime=millis();
  int LENGTH = 40;
  int blink[LENGTH];
  int color =0;
  for (int i=0;i<LENGTH;i++){
    blink[i]=random(0,NUM_LEDS);
  }
  
  while(startTime+duration>millis()){
    color=(color+5)%2550;
    leds[blink[0]]=CHSV(255, 255, 0);
    for(int i = 0; i < LENGTH; i++){
      if (i!=0){
        leds[blink[i]]=CHSV(color/10,255, (i*255)/LENGTH);
        blink[i-1]=blink[i];
      }
    }
    blink[LENGTH-1]=random(0,NUM_LEDS);
    FastLED.show();
    delay(50);  
  }
}
